/* RandomXmas v1.12 zu Weihnachten 2001 
 * Frei kopierbar, aber nur vollstndig mit diesem Spiel.cpp und Makefile und 
 * readme.txt. Vernderungen mglich, bei Weitergabe aber immer Original
 * Spiel.cpp mit beilegen,		
 * Keine Patentierungen auf Teile des oder ganzes Programm(s)*/

#include "listen.h"

//*** class Simplelist *******************************************************

Simplelist::~Simplelist()			// Delete all the list
{
   Simplelist *aid, *aidnext, *aidnextnext;

   while (next)					// while exist next
     {
	aid = this; aidnext = next;
   	while (aidnext)				// find last
     	  {
		aidnext->GetNext(aidnextnext);	
		if (!aidnextnext) aid->SetNext(NULL);
						// take out of list
		aid = aidnext;
		aidnext = aidnextnext;
     	  };
   	delete aid;				// and delete it
     };
};

void Simplelist::GetNext(Simplelist* &thisnext)
{
   thisnext = next;
};

void Simplelist::SetNext(Simplelist* newnext)
{
   next = newnext;
};

void Simplelist::GetValue(Valuetype &thisvalue)
{
   thisvalue = value;
};

void Simplelist::SetValue(Valuetype newvalue)
{
   value = newvalue;
};

void Simplelist::FindValue(Valuetype newvalue, Simplelist* &newlist)
// return one before for DelNext, doesn't find this, also if this->value is newvalue
{
   Valuetype thisvalue;
   Simplelist *aid, *aidnext;

   aid = this; aidnext = next; if (aidnext) aidnext->GetValue(thisvalue); 
   while ( thisvalue != newvalue )
     {
	aid = aidnext;					// Goto Next
	if (!(aidnext)) thisvalue = newvalue;		// If over last break	
	  else          aid->GetNext(aidnext);		// Save Next	
	if (aidnext) aidnext->GetValue(thisvalue);	// which value;
     };
   if (aid != aidnext) newlist = aid;			// found there
     else	       newlist = NULL;			// found nothing
};

int Simplelist::DelFirst()
{
   int back = 0;
   Simplelist *aidnext;

   aidnext = next;
   if (aidnext)
     {
	aidnext->GetValue(value);		// copy data from next
	aidnext->GetNext(next);
	aidnext->SetNext(NULL);			// take out of list
	delete aidnext;
     }
     else back = 1;  				// use Delete if next is empty;

   return back;
};

int Simplelist::DelNext()
{
   int back = 0;
   Simplelist *aidnext;

   aidnext = next;
   if (aidnext) 
     {
	aidnext->GetNext(next);			// take out of list
   	aidnext->SetNext(NULL);		
   	delete aidnext;				// and delete it
     }
     else back = 1;				// use delete if next is empty

   return back;
};

void Simplelist::InsLast(Simplelist* &last, Valuetype newvalue)
{
   Simplelist *aid, *aidnext;

   aid = new Simplelist(newvalue);		// Build new with value
   if (last) 
     {
	last->GetNext(aidnext);			// insert in list
	aid->SetNext(aidnext);
	last->SetNext(aid);
     };
   last = aid;					// get new last
};

void Simplelist::InsFirst(Valuetype newvalue)
{
   Simplelist *aid;

   aid = new Simplelist(value);			// Build new with this value
   aid->SetNext(next);				// Insert in list
   next = aid;
   value = newvalue;				// newvalue here
						// inslast, values exchanged
};

//*** class Stringlist *******************************************************

Stringlist::~Stringlist() 
{
   Stringlist *aid, *aidnext, *aidnextnext;

   if (textstring) delete textstring;
   while (next)					// while exist next
     {
	aid = this; aidnext = next;
   	while (aidnext)				// find last
     	  {
		aidnext->GetNext(aidnextnext);	
		if (!aidnextnext) aid->SetNext(NULL);
						// take out of list
		aid = aidnext;
		aidnext = aidnextnext;
     	  };
   	delete aid;				// and delete it
     };
};

void Stringlist::GetText(Texttype &thistext)
{
   thistext = textstring;
};

void Stringlist::SetText(Texttype newtext) 
{
   textstring = newtext;
};

void Stringlist::GetNext(Stringlist* &thisnext)
{
   thisnext = next;
};

void Stringlist::SetNext(Stringlist* newnext)
{
   next = newnext;
};

void Stringlist::InsLast(Stringlist* &last, Texttype newtext) 
{
   Valuetype newvalue;
   Stringlist *aid, *aidnext;

   aid = new Stringlist(newtext);		// Build new with newtext
   if (last) 
     {
	last->GetNext(aidnext);			// insert in list
	aid->SetNext(aidnext);
	last->SetNext(aid);
	last->GetValue(newvalue);
	newvalue++;				// use as index
	aid->SetValue(newvalue);
     };
   last = aid;					// get new last
};

void Stringlist::InsFirst(Texttype newtext) 
{
   Stringlist *aid;

   aid = new Stringlist(textstring);		// Build new with this textstring
   aid->SetNext(next);				// Insert in list
   next = aid;
   textstring = newtext;			// newvalue here
   aid->SetValue(value);			// this index in new one
   value--;   					// new value for this
						// inslast, values exchanged
};

int  Stringlist::DelFirst() 
{
   int back = 0;
   Texttype nexttext;
   Stringlist *aidnext;

   aidnext = next;
   if (aidnext)
     {
	aidnext->GetValue(value);		// copy data from next
	aidnext->GetText(nexttext);
	aidnext->SetText(textstring);		// exchange Strings
	textstring = nexttext;
	aidnext->GetNext(next);
	aidnext->SetNext(NULL);			// take out of list
	delete aidnext;
     }
     else back = 1;  				// use Delete if next is empty;

   return back;
};

int  Stringlist::DelNext() 
{
   int back = 0;
   Stringlist *aidnext;

   aidnext = next;
   if (aidnext) 
     {
	aidnext->GetNext(next);			// take out of list
   	aidnext->SetNext(NULL);		
   	delete aidnext;				// and delete it
     }
     else back = 1;				// use delete if next is empty

   return back;
};

void Stringlist::FindText(Texttype newtext, Stringlist* &newlist)
// return one before for DelNext, doesn't find this, also if this->text is newtext
{
   int thissize, newsize, comparison;
   Texttype thistext=NULL;
   Stringlist *aid, *aidnext;

   aid = this; aidnext = next; if (aidnext) aidnext->GetText(thistext); 
   thissize = strlen(thistext); 
   newsize = strlen(newtext);				
   if (thissize == newsize) 				// size as argument ?
	comparison = memcmp(thistext, newtext, newsize);
     else comparison = -1;				// sizeof not for pointer arrays
   while ( comparison != 0 )
     {
	aid = aidnext;					// Goto Next
	if (!(aidnext)) thistext = newtext;		// If over last break	
	  else          aid->GetNext(aidnext);		// Save Next	
	if (aidnext) aidnext->GetText(thistext);	// which text;
	thissize = strlen(thistext);			// size of text
   	if (thissize == newsize)
		comparison = memcmp(thistext, newtext, newsize);
     	  else comparison = -1;
     };
   if (aid != aidnext) newlist = aid;			// found there
     else	       newlist = NULL;			// found nothing
};

void Stringlist::FindValue(Valuetype newvalue, Stringlist* &newlist)
// return one before for DelNext, doesn't find this, also if this->value is newvalue
{
   Valuetype thisvalue;
   Stringlist *aid, *aidnext;

   aid = this; aidnext = next; if (aidnext) aidnext->GetValue(thisvalue); 
   while ( thisvalue != newvalue )
     {
	aid = aidnext;					// Goto Next
	if (!(aidnext)) thisvalue = newvalue;		// If over last break	
	  else          aid->GetNext(aidnext);		// Save Next	
	if (aidnext) aidnext->GetValue(thisvalue);	// which value;
     };
   if (aid != aidnext) newlist = aid;			// found there
     else	       newlist = NULL;			// found nothing
};

//*** class Doublelist *******************************************************

Doublelist::~Doublelist()
{ 
   if (prev) prev->SetNext(NULL);
   if (next) delete next;
   next = NULL;
   if (subend) subend->SetNext(NULL);	// take out of list
   if (subbegin) delete subbegin;
   subbegin = NULL;
};

void Doublelist::InsLast(Doublelist* &last, 
			Simplelist *newbegin, Simplelist *newend) 
{
   Valuetype newvalue;
   Doublelist *aid, *aidnext;

   aid = new Doublelist(newbegin, newend);	// Build new with newtext
   if (last) 
     {
	last->GetNext(aidnext);			// insert in list
	aid->SetNext(aidnext);
	last->SetNext(aid);
	if (aidnext) aidnext->SetPrev(aid);
	aid->SetPrev(last);
	last->GetValue(newvalue);
	newvalue++;				// use as index
	aid->SetValue(newvalue);
     };
   last = aid;					// get new last
};

void Doublelist::InsFirst(Simplelist *newbegin, Simplelist *newend) 
{
   Doublelist *aid, *aidnext;

   aid = new Doublelist(subbegin, subend);	// Build new with this begin, end
   aid->SetNext(next);				// Insert in list
   aidnext = next;
   next = aid;
   if (aidnext) aidnext->SetPrev(aid);
   aid->SetPrev(this);
   subbegin = newbegin;				// newvalues here
   subend = newend;
   aid->SetValue(value);			// this index in new one
   value--;   					// new value for this
						// inslast, values exchanged
};

int  Doublelist::DelFirst() 
{
   int back = 0;
   Doublelist *aidnext, *aidnextnext;

   aidnext = next;
   if (aidnext)
     {
	aidnext->GetValue(value);		// copy data from next
	aidnext->GetBegin(subbegin);
	aidnext->GetEnd(subend);
	aidnext->SetBegin(NULL);		// take out old data
	aidnext->SetEnd(NULL);
	aidnext->GetNext(aidnextnext);		// take out of list	
	if (aidnextnext) 		
	  aidnextnext->SetPrev(this);
	next = aidnextnext;
	aidnext->SetPrev(NULL);
	aidnext->SetNext(NULL);			
	delete aidnext;				// Delete it
     }
     else back = 1;  				// use Delete if next is empty;

   return back;
};

int  Doublelist::DelNext() 
{
   int back = 0;
   Doublelist *aidnext;

   aidnext = next;
   if (aidnext) 
     {
	aidnext->GetNext(next);			// take out of list
	if (next) next->SetPrev(this);
	aidnext->SetPrev(NULL);
	aidnext->SetNext(NULL);
	delete aidnext;				// and delete it
     }
     else back = 1;				// use delete if next is empty

   return back;
};

void Doublelist::FindBegin(Simplelist* newbegin, Doublelist* &newlist) 
// return one before for delnext, don't find this subbegin, also if subbegin = newbegin
{
   Valuetype val;
   Simplelist *thisbegin;
   Doublelist *aid, *aidnext;

   aid = this; aidnext = next; if (aidnext) aidnext->GetBegin(thisbegin); 
   while ( thisbegin != newbegin )
     {
	aid = aidnext;					// Goto Next
	if (!(aidnext)) thisbegin = newbegin;		// If over last break	
	  else          aid->GetNext(aidnext);		// Save Next	
	if (aidnext) aidnext->GetBegin(thisbegin);	// which begin;
     };
   if (aid != aidnext) newlist = aid;			// found there
     else	       newlist = NULL;			// found nothing
};

void Doublelist::FindEnd(Simplelist* newend, Doublelist* &newlist) 
// return one before for delnext, don't find this subend, also if subend = newend
{
   Simplelist *thisend;
   Doublelist *aid, *aidnext;

   aid = this; aidnext = next; if (aidnext) aidnext->GetEnd(thisend); 
   while ( thisend != newend )
     {
	aid = aidnext;					// Goto Next
	if (!(aidnext)) thisend = newend;		// If over last break	
	  else          aid->GetNext(aidnext);		// Save Next	
	if (aidnext) aidnext->GetEnd(thisend);		// which end;
     };
   if (aid != aidnext) newlist = aid;			// found there
     else	       newlist = NULL;			// found nothing
};

void Doublelist::FindValue(Valuetype newvalue, Doublelist* &newlist)
// return one before for DelNext, doesn't find this, also if this->value is newvalue
{
   Valuetype thisvalue;
   Doublelist *aid, *aidnext;

   aid = this; aidnext = next; if (aidnext) aidnext->GetValue(thisvalue); 
   while ( thisvalue != newvalue )
     {
	aid = aidnext;					// Goto Next
	if (!(aidnext)) thisvalue = newvalue;		// If over last break	
	  else          aid->GetNext(aidnext);		// Save Next	
	if (aidnext) aidnext->GetValue(thisvalue);	// which value;
     };
   if (aid != aidnext) newlist = aid;			// found there
     else	       newlist = NULL;			// found nothing
};

void Doublelist::GetBegin(Simplelist* &thisbegin) 
{
   thisbegin = subbegin;
};

void Doublelist::GetEnd(Simplelist* &thisend) 
{
   thisend = subend;
};

void Doublelist::SetBegin(Simplelist* newbegin) 
{
   subbegin = newbegin;
};

void Doublelist::SetEnd(Simplelist* newend) 
{
   subend = newend;
};

void Doublelist::GetPrev(Doublelist* &thisprev) 
{
   thisprev = prev;
};

void Doublelist::SetPrev(Doublelist* newprev) 
{
   prev = newprev;
};

void Doublelist::GetNext(Doublelist* &thisnext) 
{
   thisnext = next;
};

void Doublelist::SetNext(Doublelist* newnext) 
{
   next = newnext;
};

