/* Teil von RandomXmas v1.12 zu Weihnachten 2001 
 * Frei kopierbar, aber nur vollstndig mit diesem Spiel.cpp und Makefile und 
 * readme.txt. Vernderungen mglich, bei Weitergabe aber immer Original 
 * hiervon und Spiel.cpp mit beilegen,		
 * Keine Patentierungen auf Teile des oder ganzes Programm(s)*/

#include <stdlib.h>
#include <stdio.h>
#include "mann.h"

//---Klasse Mann----------------------------------

Mann::Mann(float neugroesse, float neubreite, Texture* *neutexarray)
{
  this->richtung = 0;
  this->groesse = neugroesse;
  this->breite = neubreite;
  this->posx = MAXFELD;
  this->posy = MAXFELD;
  this->jump = 0;
  this->schenken = new Geschenke(ZUMGEWINN % 100, ZUMGEWINN/100);
  texarray = neutexarray;
  qmann = gluNewQuadric();
  manndlist = glGenLists(1);
  DrawParts(manndlist);
};

Mann::~Mann()
{
  groesse = 0; breite = 0; posx = 0; posy = 0; jump = 0;
  if (glIsList(manndlist)) glDeleteLists(manndlist, 1);
  delete schenken;
  texarray = NULL;
  gluDeleteQuadric(qmann);
};

void Mann::Fahrstuhl(Spielraumtyp *spraum, int neuebene)
{
  int zufall, altebene;

  if (schenken->Fertig() == 1) neuebene = MAXEBENEN-1;
  if (neuebene > 0)				//Sonst kein Fahrstuhl da
    {
	zufall = rand() % CHVERLIEREN;
	if (schenken->Fertig() == 1) neuebene = MAXEBENEN-1;
	  else if (zufall == 0) neuebene = 0;		//Pech gehabt
 	if (spraum->aktebene == neuebene) 
          if (spraum->aktebene+1 < MAXEBENEN) neuebene++;
	    else neuebene--;
        if ((neuebene > 0) && (neuebene < MAXEBENEN-1))
	  {
		this->posx = MAXFELD;			//Vorbereiten
		this->posy = MAXFELD;
		spraum->spielraum[spraum->aktebene-1]->TrigFahrstuhl();
							//Ausschalten
		if (!(spraum->raumused[neuebene-1]))
		  {
		   	spraum->spielraum[neuebene-1] = 
					new Ebene(neuebene-1, spraum->texarray);
		  	spraum->raumused[neuebene-1] = 1;
		  }
		  else spraum->spielraum[neuebene-1]->TrigFahrstuhl();
							//Einschalten
							
		altebene = spraum->aktebene;		//Umstellen
		spraum->aktebene = neuebene;
	  }
	if (neuebene ==  0) { spraum->punkte = -1; spraum->ende = 1; };
	if (neuebene == MAXEBENEN-1) 
	  { 
		spraum->punkte = schenken->Punkte(); 
		spraum->ende   = 1;
	  };
    }
};

void Mann::AddPos(Spielraumtyp *spraum, int x, int y, int j)
{
  int neuposx, neuposy, erg;
  float xview, yview, zview;

  switch (j)
    {		// Aufladen mit j=1, dann j=0 springen(jump=2), dann aus.
	case 0 : if (jump == 1) jump = 2; else jump = 0; break;
	case 1 : if (jump < 2 ) jump = 1; break;
    };
  neuposx = this->posx + x;
  neuposy = this->posy + y;
  if ((neuposx <= MAXFELD) && (neuposx >= -MAXFELD))
    {
	if (jump < 1)
	{
	  erg = spraum->spielraum[spraum->aktebene-1]->IstDortBaum(neuposx, neuposy);
	  if (erg <= -1) this->posx = neuposx;
          if (erg >=  0) schenken->AddAnz(erg/100, erg % 10, (erg % 100)/10 );
	  if (erg <= -2) this->Fahrstuhl( spraum, -((erg%100)+2) );
	}
	else { 
		this->posx = neuposx;
		erg = spraum->spielraum[spraum->aktebene-1]->GetDarueber(neuposx, neuposy);
		schenken->AddAnz(erg/100, erg % 10, (erg % 100)/10);
	     }
    }
  if ((neuposy <= MAXFELD) && (neuposy >= -MAXFELD))
    {
	if (jump < 1)
	{
	  erg = spraum->spielraum[spraum->aktebene-1]->IstDortBaum(neuposx, neuposy);
	  if (erg <= -1) this->posy = neuposy;
	  if (erg >=  0) schenken->AddAnz(erg/100, erg % 10, (erg % 100)/10 );
	  if (erg <= -2) this->Fahrstuhl( spraum, -(erg+2) );
	}
	else this->posy = neuposy;
    }
  xview = sin(richtung*3.1415/180)*MAXFELD*4;
  if (jump == 2) yview = groesse/4 + MAXFELDHOEHE*FELDEINHEIT/4;
    else	 yview = groesse/4;
  zview = cos(richtung*3.1415/180)*MAXFELD*4;
  if (spraum->blickmann)
    {
        glLoadIdentity();
	gluLookAt(posx*2, 5*yview, posy*2,
		  posx*2-xview, -10*yview, posy*2-zview, 0, 1, 0);
    };
};

void Mann::NeuRichtung(int winkel)
{
  this->richtung = winkel;
}

int Mann::GetRichtung()
{
  return richtung;
};

void Mann::DrawParts(GLuint listdisplay)
{
  GLfloat mann_amb_black[] = {0, 0, 0}, mann_amb_red[] = {1.0, 0, 0};
  GLfloat mann_amb_orange[] = {1.0, 0.7, 0.7}, light_null[] = {0.4, 0.4, 0.4};

  float sizeunit, widthunit;
  int detail;

  if (MANNDETAILS) detail = DETAILS;
    else	   detail = 10;
  sizeunit = groesse / 10;
  widthunit = this->breite / 2;
  glNewList(listdisplay, GL_COMPILE);			// until end
  glRotatef(-90, 1, 0, 0);

  glTranslatef(-widthunit, widthunit, 0);
  if (texarray[6])
	glBindTexture(GL_TEXTURE_2D, texarray[6]->GetTexNumber() );
  glColor3f(0.0, 0.0, 0.0);
  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mann_amb_black);
  gluCylinder(qmann, widthunit, widthunit, sizeunit, detail, detail/2);		// Schuhe
  glTranslatef(widthunit*2, 0, 0);
  gluCylinder(qmann, widthunit, widthunit, sizeunit, detail, detail/2);
  glBindTexture(GL_TEXTURE_2D, 0);

  glTranslatef(-widthunit, -widthunit, sizeunit);
  if (texarray[5])
	glBindTexture(GL_TEXTURE_2D, texarray[5]->GetTexNumber() );
  glColor3f(1.0, 0.0, 0.0);
  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mann_amb_red);
  gluCylinder(qmann, widthunit*2, widthunit, 7.5*sizeunit, detail, detail/2);	// Krper
  glBindTexture(GL_TEXTURE_2D, 0);

  glTranslatef(0, 0, 7.5*sizeunit);
  glRotatef(90, 1, 0, 1);
  if (texarray[4])
	glBindTexture(GL_TEXTURE_2D, texarray[4]->GetTexNumber() );
  glColor3f(1.0, 0.7, 0.7);
  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mann_amb_orange);
  gluSphere(qmann, 1.2*sizeunit, detail, detail);				// Kopf
  glRotatef(270, 1, 0, 1);
  glBindTexture(GL_TEXTURE_2D, 0);

  glTranslatef(0, -sizeunit/2, sizeunit/2);
  glRotatef(45, 1, 0, 0);
  if (texarray[3])
	glBindTexture(GL_TEXTURE_2D, texarray[3]->GetTexNumber() );
  glColor3f(1.0, 0.0, 0.0);
  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mann_amb_red);
  gluCylinder(qmann, 1.4*sizeunit, 0, this->groesse/3, detail, detail/2);	// Mtze
  glRotatef(-45, 1, 0, 0);
  glBindTexture(GL_TEXTURE_2D, 0);

  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, light_null);
  glRotatef(90, 1, 0, 0);
  glEndList();
};

void Mann::DrawMann()
{
  glPushMatrix();
  if (jump == 2) glTranslatef(posx * 2, MAXFELDHOEHE*FELDEINHEIT, posy * 2);
    else glTranslatef(posx * 2, 0, posy * 2);
  glRotatef(richtung, 0, 1, 0);

  glCallList(manndlist);

  glRotatef(-richtung, 0, 1, 0); 
  if (jump == 1) glTranslatef(0, -(MAXFELDHOEHE-2)*FELDEINHEIT, 0);
  glPopMatrix();
  schenken->DrawGeschenke();
}

