/* RandomXmas v1.12 zu Weihnachten 2001 
 * Frei kopierbar, aber nur vollstndig mit diesem Spiel.cpp und Makefile und 
 * readme.txt. Vernderungen mglich, bei Weitergabe aber immer Original
 * Spiel.cpp mit beilegen,		
 * Keine Patentierungen auf Teile des oder ganzes Programm(s)*/
// Joystick nicht getestet !
//
//***Vereinbarungen****************************
//---Includes, Konstanten----------------------

#include <GL/glut.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/timeb.h>
#include <string.h>

#include "mann.h"
#include "ebenefeld.h"
#include "konstanten.h"
#include "listen.h"

//---Typen- und Klassendefiniton----------------

class Highscoreboard
  {
	public:
		Highscoreboard();
		~Highscoreboard();
		void DrawBoard();
		void Scroll(int numofpages);
	private:
		void Readfile();
		void LoadPage();
		void Writefile();
		int imax;				// number of lines
		const static short pagesize = 10;
		const static short linesize = 100;
   		char punktstring[linesize];
   		Doublelist *scorepagelist, *pagenow;
		GrafikAusgabe *topten[pagesize+3];
  };
	
//--- globale Variablen -----------------------

int		aktxwinkel, aktywinkel, aktzwinkel;
float		aktxtrans, aktytrans, aktztrans;
int 		aktwidth, aktheight;
int 		trans=0, winkel=1, reshape=0;
int		joystickx, joysticky;
char		*highscorefile=0, *vorname=0, *nachname=0;

Spielraumtyp	*spraum;
Mann		*weihmann;		
Highscoreboard  *highscore;

//***Methoden der Klassen*************************

//--- Klasse Highscoreboard ----------------------

Highscoreboard::Highscoreboard()
{
   int i;
   struct timeb tp;
   char zeit[24];

   imax = 0;
   scorepagelist = NULL;
   for(i=0; i<linesize; i++) punktstring[i] = ' ';
   for(i=0; i<pagesize+3; i++) 
     {
	topten[i] = new GrafikAusgabe(-4*MAXFELD, MAXFELD/2*(8 - i), -5*MAXFELD/2, 0);
	topten[i]->SetSize(MAXFELD/3);
	topten[i]->SetColor(1.0, 1.0, 1.0);
	topten[i]->SetText("");
     };
   sprintf(punktstring, "%d ", spraum->punkte);
   i=ftime(&tp);
   strncpy(zeit, ctime(&tp.time), strlen(ctime(&tp.time)) + 1 );
   strncat(punktstring, zeit, strlen(zeit) - 1);
   strcat(punktstring, " ");
   if (vorname) strcat(punktstring, vorname);
   strcat(punktstring, " ");
   if (nachname) strcat(punktstring, nachname);

   Readfile();
   pagenow = scorepagelist;
   LoadPage();
};

   
Highscoreboard::~Highscoreboard()
{
   int i;

   Writefile();
   delete scorepagelist;
   for(i=0;i<  12;i++) delete topten[i];
};

void Highscoreboard::Scroll(int numofpages)
{
   Doublelist *following;

   following = NULL;
   if (numofpages < 0)
     while (numofpages < 0)
       {
		if (pagenow) pagenow->GetPrev(following);
		if (following) pagenow = following;
		  else	       numofpages = -1;			// break loop
		numofpages++;
       };
   if (numofpages > 0)
     while (numofpages > 0)
       {
		if (pagenow) pagenow->GetNext(following);
		if (following) pagenow = following;
		  else	       numofpages = +1;			// break loop
		numofpages--;
       };
   LoadPage();
};

void Highscoreboard::Readfile()
{
   int	i=0, highpunkte, test;
   FILE *fpr;
   char zeile[linesize], *thisline;
   Stringlist *pagebegin, *pageend, *scorelist, *scorelistlast;
   Doublelist *lastpage;

   pagebegin = NULL; pageend = NULL; scorelist = NULL; scorelistlast = NULL;
   lastpage = NULL;
   if (highscorefile) fpr = fopen(highscorefile, "r");
     else fpr = NULL;
   if (fpr) 
     {
	rewind(fpr);
	i = 0;
	if (fpr) 
          while (fgets(zeile, linesize, fpr))
           {
		thisline = new char[ strlen(zeile) + 1 ];
		strcpy(thisline, zeile);
		if (i == 0) 
		  { 
			scorelist = new Stringlist(thisline);
			scorelistlast = scorelist;
		  }
		  else scorelist->InsLast(scorelistlast, thisline);
		if ((i % pagesize) == 0) 
		  pagebegin = scorelistlast;
		if ((i % pagesize) == pagesize - 1)
		  {
			pageend = scorelistlast;
			if (scorepagelist) 
			  scorepagelist->InsLast(lastpage, pagebegin, pageend);
			  else {
					scorepagelist = new Doublelist(pagebegin, pageend);
					lastpage = scorepagelist;
			       };
			pagebegin = NULL; pageend = NULL;
		  };
		i = i + 1;
	  	imax = i;
           }
	if (pagebegin)		// save rest in list
	  {
		if (scorepagelist)
		  scorepagelist->InsLast(lastpage, pagebegin, pageend);
		  else {
				scorepagelist = new Doublelist(pagebegin, pageend);
				lastpage = scorepagelist;
		       };
		pagebegin = NULL; pageend = NULL;
	  };	
	fclose(fpr);
     }
};

void Highscoreboard::LoadPage()
{
   int i = 0;
   char *zeile;
   Simplelist *begin = NULL;
   Stringlist *pagebegin = NULL, *aidnext = NULL;

   zeile = new char[linesize];
   if (pagenow) pagenow->GetValue(i);
     else	      i = 0;
   sprintf(zeile, "Highscore: Plaetze %d-%d", i * pagesize + 1, (i+1) * pagesize);   
   topten[0]->SetText(zeile);
   i = 0;
   if (pagenow) pagenow->GetBegin(begin);
   if (begin) pagebegin = (Stringlist *) begin;
   while (i < pagesize)
     {
	if (pagebegin) 
	  {
		pagebegin->GetText(zeile);		// Read line
		topten[i+1]->SetText(zeile);		// insert in showtable
		pagebegin->GetNext(aidnext);		// go to next
		pagebegin = aidnext;
	  }
	  else topten[i+1]->SetText("");
	i = i + 1;
     }
   topten[pagesize+1]->SetText("Deine Punkte");
   topten[pagesize+2]->SetText(punktstring);
};

void Highscoreboard::Writefile()
{
   int	i=0, highpunkte;
   FILE *fpr;
   char *zeile;
   Simplelist *begin = NULL;
   Stringlist *scorenow = NULL, *aidnext = NULL;

   i=0;
   fpr = fopen(highscorefile, "w");
   if (fpr)
     {
	if (scorepagelist) scorepagelist->GetBegin(begin);		// first line
	if (begin)
	  {
		scorenow = (Stringlist*) begin;
		scorenow->GetText(zeile);				// Read line
		scorenow->GetNext(aidnext);				// Go to next
		scorenow = aidnext;
	  };
	if (imax > 0) highpunkte = strtol(zeile, (char **)NULL, 10);
	  else highpunkte = -1;
   	i=0;
   	while ( (highpunkte > spraum->punkte) && (i < imax) )
     	  {
		fprintf(fpr, zeile);
		if (scorenow)
		  {
			scorenow->GetText(zeile);			// Read line
			scorenow->GetNext(aidnext);			// Go to next
			scorenow = aidnext;
		  } 
		  else zeile = NULL;
		if (zeile) highpunkte = atoi(zeile);
		  else highpunkte = 0; 	
     	  };
   	fprintf(fpr, punktstring);
   	fprintf(fpr, "\r\n");		//Dos-Kompatibel
   	while (i < imax) 
     	  {
		fprintf(fpr, zeile);
		if (scorenow)
		  {
			scorenow->GetText(zeile);			// Read line
			scorenow->GetNext(aidnext);			// Go to next
			scorenow = aidnext;
		  }
		  else i = imax;
     	  }	
   	fclose(fpr);
     }
    else 
     { 
	printf(punktstring);
	printf("\r\n");			//Dos-Kompatibel
     } 
};

void Highscoreboard::DrawBoard()
{
   int i;

   for(i=0; i < pagesize+3; i++)
	if (topten[i]) topten[i]->DrawAusgabe();
};

//***Funktionen, OpenGL-Grundlagen***********************

void initVars()
{
  aktxwinkel = 0; aktywinkel = 0; aktzwinkel = 0;
  aktxtrans = 0; aktytrans = 0; aktztrans = 0;
  aktwidth = ANFWIDTH; aktheight = ANFHEIGHT;
};

void initTextur(const char* texfile, Texture* &thistex)
{
  short   usable;
  FILE	  *fpr;

  thistex = NULL;
  fpr = fopen(texfile, "r");
  if (fpr) usable = 1;
    else   usable = 0;
  if (fpr) fclose(fpr);
  if (usable)  
   {
	thistex = new Texture(0.0, 0.0, 0.0);
	thistex->Readbmp(texfile);
   };
};

void initVarsTwo()
{
  int i;

  spraum = new Spielraumtyp;
  spraum->aktebene = 1; spraum->punkte = 0; spraum->ende = 0;
  spraum->blickmann = 0;
  for(i=0; i<NUMOFTEX; i++)
	spraum->texarray[i] = NULL;
  initTextur(FILETEXEBENE,   spraum->texarray[0]);
  initTextur(FILETEXHUEGEL,  spraum->texarray[1]);
  initTextur(FILETEXBAUM,    spraum->texarray[2]);
  initTextur(FILETEXCAP,     spraum->texarray[3]);
  initTextur(FILETEXHEAD,    spraum->texarray[4]);
  initTextur(FILETEXBODY,    spraum->texarray[5]);
  initTextur(FILETEXSHOES,   spraum->texarray[6]);
  for(i=0; i < MAXEBENEN-2; i++)
    {
	spraum->spielraum[i] = NULL;
	spraum->raumused[i] = 0;
    };
  spraum->spielraum[spraum->aktebene - 1] = 
			new Ebene(spraum->aktebene-1, spraum->texarray);
  spraum->raumused[spraum->aktebene - 1 ] = 1;
  weihmann = new Mann(3, 0.6, spraum->texarray);
};

//---Ende + Darstellungsfunktion, greift auf die Klassen zu-------

void endeproc()
{ 
   int i;

   delete highscore;
   for(i=0; i < MAXEBENEN-2; i++)
     {
	if ( spraum->spielraum[i] ) delete spraum->spielraum[i];
	spraum->raumused[i] = 0;
     };
   delete weihmann;
   for(i=0; i < NUMOFTEX; i++)
     {
        if (spraum->texarray[i]) delete spraum->texarray[i];
     };
   delete spraum;
   exit(0);
}

void display(void)
{  
  glEnable(GL_DEPTH_TEST);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glPushMatrix();
  glTranslatef(aktxtrans/5, aktytrans/5, aktztrans/5);
  if (spraum->ende == 1) glRotatef(aktxwinkel-24, 1, 0, 0);
		    else glRotatef(aktxwinkel, 1, 0, 0);
  glRotatef(aktywinkel, 0, 1, 0);
  glRotatef(aktzwinkel, 0, 0, 1);

  if (spraum->ende == 0) 
    {
  	spraum->spielraum[spraum->aktebene-1]->DrawEbene();
	weihmann->DrawMann();
    }
  else 
    {
	if (spraum->ende == 1) if (!highscore) highscore = new Highscoreboard(); 
		 	   	  else highscore->DrawBoard();
	if (spraum->ende == 2) endeproc();
    };
  glFlush();
  glPopMatrix();
  glutSwapBuffers();
}

//---Einstellungen fr Darstellung-----------------------------

void init (void)
{
   GLfloat light_amb[] = {0.6, 0.6, 0.6}, light_null[] = { 0.4, 0.4, 0.4 };

   glClearColor (0.0, 0.0, 0.0, 0.0);
   glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);

   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluPerspective(60, 1, 1, 15*MAXFELD);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
   gluLookAt(0, MAXFELD*7/2, MAXFELD*5, 0, MAXFELD, 0, 0, 1, 0);

   glLightModelfv(GL_LIGHT_MODEL_AMBIENT, light_amb);
   glEnable(GL_LIGHT0);
   glEnable(GL_LIGHTING);
   glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, light_null);
   glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, light_null);
   glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, light_null);
}

void DoReshape(int width, int height)
{
   int minsize, maxsize;

   aktwidth = width; aktheight = height;
   if (width >= height) { minsize = height; maxsize = width; }
     else { minsize = width; maxsize = height; };
   
   glViewport(0, 0, width, height);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluPerspective(60*maxsize/minsize, 1, 1, 15*MAXFELD);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
   gluLookAt(0, MAXFELD*7/2, MAXFELD*5, 0, MAXFELD, 0, 0, 1, 0);
}

//---Tastatur-Eingabeverarbeitung-----------------------------

static void joystickfunc(unsigned int buttonMask, int x, int y, int z)
{
  short xl, yl, xr, yr, xu, yu, xd, yd, wl, wr, wu, wd;
  int	movex, movey;
  int   winkel;

  if (spraum->blickmann) winkel = (360-weihmann->GetRichtung()) % 360;
    else		 winkel = aktywinkel;
  if ((winkel <= 45) || (winkel > 315))
    { xl=-1; yl=0; xr=1; yr=0; xu=0; yu=-1; xd=0; yd=1;
 	wl=90; wr=270; wu=0; wd=180;};
  if ((winkel > 45) && (winkel <= 135)) 
    {xl=0; yl=-1; xr=0; yr=1; xu=1; yu=0; xd=-1; yd=0;
	wl=0; wr=180; wu=270; wd=90; };
  if ((winkel > 135) && (winkel <= 225)) 
    {xl=1; yl=0; xr=-1; yr=0; xu=0; yu=1; xd=0; yd=-1;
	wl=270; wr=90; wu=180; wd=0; };
  if ((winkel > 225) && (winkel <= 315))
    {xl=0; yl=1; xr=0; yr=-1; xu=-1; yu=0; xd=1; yd=0;
	wl=180; wr=0; wu=90; wd=270; }; 
  
  movex = x - joystickx;				//Pos-Differenz
  movey = y - joysticky;
  if ( movex >= movey) movey = 0; else movex = 0;	//nicht diagonal
  if (buttonMask & GLUT_JOYSTICK_BUTTON_A)
	weihmann->AddPos(spraum, 0, 0, 1);
  if (movex < 10) { weihmann->NeuRichtung(wl); 	//Links
	weihmann->AddPos(spraum, xl, yl, 0); };
  if (movex > 10) { weihmann->NeuRichtung(wr); 	//Rechts
	weihmann->AddPos(spraum, xr, yr, 0);};
  if (movey < 10) { weihmann->NeuRichtung(wu);	//Unten
	weihmann->AddPos(spraum, xu, yu, 0);};
  if (movey > 10) { weihmann->NeuRichtung(wd);	//Oben
	weihmann->AddPos(spraum, xd, yd, 0);};
  joystickx = x; joysticky = y;
  glutPostRedisplay();
}

static void specialkey(int key, int x, int y)
{
  short xl, yl, xr, yr, xu, yu, xd, yd, wl, wr, wu, wd;
  int   winkel;

  if (spraum->blickmann) winkel = (360-weihmann->GetRichtung()) % 360;
    else		 winkel = aktywinkel;
  if ((winkel <= 45) || (winkel > 315))
    { xl=-1; yl=0; xr=1; yr=0; xu=0; yu=-1; xd=0; yd=1;
 	wl=90; wr=270; wu=0; wd=180;};
  if ((winkel > 45) && (winkel <= 135)) 
    {xl=0; yl=-1; xr=0; yr=1; xu=1; yu=0; xd=-1; yd=0;
	wl=0; wr=180; wu=270; wd=90; };
  if ((winkel > 135) && (winkel <= 225)) 
    {xl=1; yl=0; xr=-1; yr=0; xu=0; yu=1; xd=0; yd=-1;
	wl=270; wr=90; wu=180; wd=0; };
  if ((winkel > 225) && (winkel <= 315))
    {xl=0; yl=1; xr=0; yr=-1; xu=-1; yu=0; xd=1; yd=0;
	wl=180; wr=0; wu=90; wd=270; }; 
  
  switch (key) {
     case GLUT_KEY_END	 : weihmann->AddPos(spraum, 0, 0, 1); break;
     case GLUT_KEY_LEFT  : weihmann->NeuRichtung(wl);
			   weihmann->AddPos(spraum, xl, yl, 0); break;
     case GLUT_KEY_RIGHT : weihmann->NeuRichtung(wr);
			   weihmann->AddPos(spraum, xr, yr, 0); break;
     case GLUT_KEY_UP    : weihmann->NeuRichtung(wu);
			   weihmann->AddPos(spraum, xu, yu, 0); break;
     case GLUT_KEY_DOWN  : weihmann->NeuRichtung(wd);
			   weihmann->AddPos(spraum, xd, yd, 0); break;
     case GLUT_KEY_PAGE_UP : if (highscore) highscore->Scroll(-1); break;
     case GLUT_KEY_PAGE_DOWN : if (highscore) highscore->Scroll(+1); break;
     }
   glutPostRedisplay();
}

static void key(unsigned char k, int x, int y)
{
  switch (k) {
     case 'v' : trans=1; winkel=0; reshape=0; break;
     case 'd' : winkel=1; trans=0; reshape=0; break;
     case 'r' : reshape=1; trans=0; winkel=0; break;
     case 'p' : weihmann->TriggerPunktAnz(); break;
     case 'b' : if (spraum->blickmann)
		  {
			spraum->blickmann = 0;
   			glLoadIdentity();
   			gluLookAt(0, MAXFELD*7/2, MAXFELD*5,
				  0, MAXFELD, 0, 0, 1, 0);
		  }
		  else		       spraum->blickmann = 1; break;
     case 27  : spraum->ende = spraum->ende + 1; break;
     }
  if (winkel)
   switch (k) {
     case 'x' : aktxwinkel = (aktxwinkel + 30) % 360; break;
     case 'X' : aktxwinkel = (aktxwinkel - 30) % 360; break;
     case 'y' : aktywinkel = (aktywinkel + 30) % 360; break;
     case 'Y' : aktywinkel = (aktywinkel - 30) % 360; break;
     case 'z' : aktzwinkel = (aktzwinkel + 30) % 360; break;
     case 'Z' : aktzwinkel = (aktzwinkel - 30) % 360; break;     
     case 'i' : aktxwinkel = 0; aktywinkel = 0; aktzwinkel = 0; break; 
   }
  if (trans)
   switch (k) {
     case 'x' : aktxtrans = (aktxtrans + 1) ; break;
     case 'X' : aktxtrans = (aktxtrans - 1) ; break;
     case 'y' : aktytrans = (aktytrans + 1) ; break;
     case 'Y' : aktytrans = (aktytrans - 1) ; break;
     case 'z' : aktztrans = (aktztrans + 1) ; break;
     case 'Z' : aktztrans = (aktztrans - 1) ; break;     
     case 'i' : aktxtrans = 0; aktytrans = 0; aktztrans = 0; break;
    }
  if (reshape)
    switch (k) {
     case 'x' : aktwidth = (aktwidth + 10) ; break;
     case 'X' : if (aktwidth>10) aktwidth = (aktwidth - 10) ; break;
     case 'y' : aktheight = (aktheight + 10) ; break;
     case 'Y' : if (aktheight>10) aktheight = (aktheight - 10) ; break;    
     case 'i' : aktwidth = ANFWIDTH; aktheight = ANFHEIGHT; break;
    }  
  if (reshape) glutReshapeWindow(aktwidth, aktheight);
  glutPostRedisplay();
}

//---Hauptprogramm---------------------------------------------

int main(int argc, char** argv)
{
   if (argc >= 1) highscorefile = argv[1];
   if (argc >= 2) vorname = argv[2];
   if (argc >= 3) nachname = argv[3]; else nachname = "RandomXmas 1.12";
   initVars();

   glutInit(&argc, argv);
   glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);
   glutInitWindowPosition (100, 100);
   glutCreateWindow ("spiel");
   init();
   initVarsTwo();

   glutDisplayFunc(display);
   glutReshapeFunc(DoReshape);
   glutKeyboardFunc(key);
   glutSpecialFunc(specialkey);
   glutJoystickFunc(joystickfunc, 10);
   glutReshapeWindow(aktwidth, aktheight);

   glutMainLoop();

   return 0; 
}

